  //+------------------------------------------------------------------+
//|                                                  MACD Sample.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+

extern double TakeProfit = 3000;
extern double StopLoss = 10000;
extern double Lots = 0.01;
extern double TrailingStop = 10000;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double
   MacdCurrent,
   MacdPrevious,
   MacdsCurrent,
   MacdsPrevious,
   MacdPrevious1,
   MacdPrevious2,
   MacdPrevious3,
   StdDev0,
   StdDev1,
   StdDev2,
   StdDev3,
   StdDev4;
   int
   a,
   buy,
   sell,
   cnt,
   ticket,
   total;
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
// to simplify the coding and speed up access
// data are put into internal variables
   MacdCurrent=iMACD(NULL,0,12,26,9,PRICE_TYPICAL,MODE_MAIN,0);
   MacdPrevious=iMACD(NULL,0,12,26,9,PRICE_TYPICAL,MODE_MAIN,1);
   MacdsCurrent=iMACD(NULL,0,12,26,9,PRICE_TYPICAL,MODE_SIGNAL,0);
   MacdsPrevious=iMACD(NULL,0,12,26,9,PRICE_TYPICAL,MODE_SIGNAL,1);
   MacdPrevious1=iMACD(NULL,0,12,26,9,PRICE_TYPICAL,MODE_MAIN,2);
   MacdPrevious2=iMACD(NULL,0,12,26,9,PRICE_TYPICAL,MODE_MAIN,3);
   MacdPrevious3=iMACD(NULL,0,12,26,9,PRICE_TYPICAL,MODE_MAIN,4);
   StdDev0=iStdDev(NULL,0,20,0,MODE_SMMA,PRICE_CLOSE,0);
   StdDev1=iStdDev(NULL,0,20,0,MODE_SMMA,PRICE_CLOSE,1);
   StdDev2=iStdDev(NULL,0,20,0,MODE_SMMA,PRICE_CLOSE,2);
   StdDev3=iStdDev(NULL,0,20,0,MODE_SMMA,PRICE_CLOSE,3);
   StdDev4=iStdDev(NULL,0,20,0,MODE_SMMA,PRICE_CLOSE,4);
   total=OrdersTotal();
   if(total<2) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(0.1*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
        
        
       // count buy and sell orders
//+------------------------------------------------------------------+
//|                                                                   |
//+------------------------------------------------------------------+       
   a=0;
   buy=0;
   sell=0;     
        
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {buy=1;}
        

         else // go to short position
           {sell=1;}
      
        }
     }
      // check for long position (BUY) possibility
//+------------------------------------------------------------------+
//|                                                                   |
//+------------------------------------------------------------------+
      if(a==1 && MacdPrevious<0 && MacdCurrent>0 && MacdPrevious1<0)
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Bid-StopLoss*Point,Ask+TakeProfit*Point,"macd sample",16384,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
      if(a==1 && MacdPrevious>0 && MacdCurrent<0 && MacdPrevious1>0)
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Ask+StopLoss*Point,Bid-TakeProfit*Point,"macd sample",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
               if(MacdsPrevious<0 && MacdsCurrent>0/* || MacdsPrevious<0 && MacdsCurrent>0*/)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,30,Violet); // close position
                 return(0); // exit
                }

            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // should it be closed?
               if(MacdsPrevious>0 && MacdsCurrent<0/* || MacdsPrevious>0 && MacdsCurrent<0*/)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,30,Violet); // close position
                 return(0); // exit
                }

            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
// the end.